let app = {
  bindInfo: function () {
    let e = document.querySelectorAll(".ident li");
    document
      .querySelector(".bind-info")
      .addEventListener("click", function (t) {
        e[0].querySelector("input").value.trim().length > 0 &&
        e[1].querySelector("input").value.trim().length > 0 &&
        e[2].querySelector("input").value.trim().length > 0 &&
        e[3].querySelector("textarea").value.trim().length > 0
          ? (chrome.storage.sync.set({
              url: e[0].querySelector("input").value,
              cid: e[1].querySelector("input").value,
              code: e[2].querySelector("input").value,
              taglist: e[3].querySelector("textarea").value,
            }),
            ajaxText.createButterbar("保存配置信息成功~"))
          : ajaxText.createButterbar("大哥，你别忽悠我，快配置~");
      }),
      app.ajaxText();
  },
  saveInfo: function () {
    let e = document.querySelectorAll(".ident li");
    chrome.storage.sync.get(["url", "cid", "code", "taglist"], function (t) {
      t.url && t.cid && t.code && t.taglist
        ? ((e[0].querySelector("input").value = t.url),
          (e[1].querySelector("input").value = t.cid),
          (e[2].querySelector("input").value = t.code),
          (e[3].querySelector("textarea").value = t.taglist))
        : (document.querySelector(".input_body").classList.add("input-open"),
          ajaxText.createButterbar("请点击头像配置信息~"));
    }),
      app.ajaxText();
  },
  sendTalk: function () {
    let e = document.querySelectorAll(".ident li");
    document
      .querySelector(".submit_btn button")
      .addEventListener("click", function (t) {
        t.preventDefault();
        let _ = document.querySelector(".textarea_box").value;
        _.trim().length > 0 &&
        e[0].querySelector("input").value.trim().length > 0 &&
        e[1].querySelector("input").value.trim().length > 0 &&
        e[2].querySelector("input").value.trim().length > 0 &&
        e[3].querySelector("textarea").value.trim().length > 0
          ? chrome.storage.sync.get(["url", "cid", "code"], function (e) {
              let t = {
                  action: "send_talk",
                  talk_code: e.code,
                  cid: e.cid,
                  token: navigator.userAgent,
                  content: _,
                },
                r = [];
              for (let l in t) r.push({ key: l, value: t[l] });
              let a = `${r[0].key}=${r[0].value}&${r[1].key}=${r[1].value}&${r[2].key}=${r[2].value}&${r[3].key}=${r[3].value}&${r[4].key}=${r[4].value}`;
              fetch(e.url, {
                method: "POST",
                headers: {
                  "Content-type":
                    "application/x-www-form-urlencoded; charset=UTF-8",
                },
                body: a,
              })
                .then((e) => e.text())
                .then((e) => console.log(e)),
                (document.querySelector(".textarea_box").value = ""),
                ajaxText.createButterbar("发送成功~");
            })
          : ajaxText.createButterbar("大哥，你快填内容呀~");
      }),
      app.ajaxText();
  },
  owo: function () {
    new OwO({
      logo: "OωO",
      container: document.querySelector(".OwO"),
      target: document.querySelector(".textarea_box"),
      api: "static/OwO.json",
      position: "down",
      width: "100%",
      maxHeight: "250px",
    }),
      (function e(t) {
        let _ = !1;
        t.addEventListener("click", () => {
          if (_) return;
          let e = document.querySelectorAll(".OwO-items li img");
          for (let t of e)
            (t.src = t.getAttribute("data-src")), t.removeAttribute("data-src");
          _ = !0;
        });
      })(document.querySelector(".OwO"));
  },
  tagTalkBtn: function () {
    let e, t;
    (e = document.querySelector("form")),
      (t = document.querySelector("textarea")).addEventListener("focus", () =>
        e.classList.add("textarea-style")
      ),
      t.addEventListener("blur", () => e.classList.remove("textarea-style")),
      (function e() {
        let t = document.querySelector("#app");
        function _() {
          let e = document.querySelector(".talk-tag");
          e.classList.contains("tag-list-close")
            ? e.classList.remove("tag-list-close")
            : e.classList.add("tag-list-close");
        }
        chrome.storage.sync.get(["taglist"], function (e) {
          let r = e.taglist;
          if (r) {
            let l = JSON.parse(r),
              a = document.createDocumentFragment(),
              n = document.createElement("ul");
            for (let o of ((n.className = "talk-tag"), l)) {
              let i = document.createElement("li"),
                $ = document.createElement("a");
              $.href = "javascript:;";
              let c = document.createElement("i");
              c.innerHTML =
                '<svg width="18" height="18" viewBox="0 0 18 18" fill="none" xmlns="http://www.w3.org/2000/svg"><path fill-rule="evenodd" clip-rule="evenodd" d="M5.65041 15.4951C5.67821 15.4984 5.706 15.5 5.73215 15.5C6.09998 15.5 6.41549 15.2238 6.45636 14.8511L6.79185 11.8304H10.0254L9.70793 14.6892C9.66216 15.0897 9.95151 15.451 10.352 15.4951C10.3798 15.4984 10.4076 15.5 10.4338 15.5C10.8 15.5 11.1171 15.2238 11.158 14.8511L11.4935 11.8304H14.7709C15.1747 11.8304 15.5016 11.5034 15.5 11.1013C15.5 10.6992 15.1747 10.3723 14.7709 10.3723H11.6554L12.0156 7.12925H14.7709C15.1747 7.12925 15.5 6.80233 15.5 6.40022C15.5 5.99811 15.1747 5.67119 14.7709 5.67119H12.1775L12.4952 2.81062C12.541 2.41014 12.2516 2.0489 11.8511 2.00476C11.449 1.95899 11.0893 2.24832 11.0452 2.64879L10.7095 5.67119H7.4759L7.79361 2.81062C7.83938 2.41014 7.55003 2.0489 7.14951 2.00476C6.74735 1.95899 6.3877 2.24832 6.34356 2.64879L6.00788 5.67119H2.72911C2.32696 5.67119 2 5.99811 2 6.40022C2 6.80233 2.32532 7.12925 2.72911 7.12925H5.84595L5.48577 10.3723H2.72911C2.32696 10.3723 2 10.6976 2 11.1013C2 11.5034 2.32532 11.8304 2.72911 11.8304H5.32383L5.00631 14.6892C4.96054 15.0897 5.24989 15.451 5.65041 15.4951ZM7.31397 7.12925L6.95379 10.3723H10.1874L10.5476 7.12925H7.31397Z" fill="#9D9D9D"/></svg>';
              let u = document.createElement("span");
              if (
                ((u.innerHTML = o.parent.substring(1)),
                $.appendChild(c),
                $.appendChild(u),
                i.appendChild($),
                o.children.length > 0)
              ) {
                let s = document.createElement("div");
                (s.className = "child-tag"),
                  (s.innerHTML =
                    '<svg width="16" height="16" viewBox="0 0 16 16" fill="none" xmlns="http://www.w3.org/2000/svg"><path d="M11.3221 7.24863L6.27796 1.73946C6.00608 1.43896 5.53387 1.4175 5.24052 1.69653C4.94002 1.96841 4.91856 2.44063 5.19759 2.73397L9.79096 7.74947L5.19044 12.7721C4.91856 13.0726 4.94002 13.5377 5.24052 13.8096C5.54102 14.0814 6.00608 14.06 6.27796 13.7595L11.3149 8.24315C11.3221 8.22884 11.3364 8.22168 11.3435 8.20737C11.5796 7.93549 11.5725 7.52052 11.3221 7.24863V7.24863Z" fill="#9D9D9D"/></svg>');
                let p = document.createElement("ol");
                for (let d of o.children)
                  if (d.length > 0) {
                    let y = document.createElement("li"),
                      g = document.createElement("a");
                    g.href = "javascript:;";
                    let v = document.createElement("i");
                    v.innerHTML =
                      '<svg width="18" height="18" viewBox="0 0 18 18" fill="none" xmlns="http://www.w3.org/2000/svg"><path fill-rule="evenodd" clip-rule="evenodd" d="M5.65041 15.4951C5.67821 15.4984 5.706 15.5 5.73215 15.5C6.09998 15.5 6.41549 15.2238 6.45636 14.8511L6.79185 11.8304H10.0254L9.70793 14.6892C9.66216 15.0897 9.95151 15.451 10.352 15.4951C10.3798 15.4984 10.4076 15.5 10.4338 15.5C10.8 15.5 11.1171 15.2238 11.158 14.8511L11.4935 11.8304H14.7709C15.1747 11.8304 15.5016 11.5034 15.5 11.1013C15.5 10.6992 15.1747 10.3723 14.7709 10.3723H11.6554L12.0156 7.12925H14.7709C15.1747 7.12925 15.5 6.80233 15.5 6.40022C15.5 5.99811 15.1747 5.67119 14.7709 5.67119H12.1775L12.4952 2.81062C12.541 2.41014 12.2516 2.0489 11.8511 2.00476C11.449 1.95899 11.0893 2.24832 11.0452 2.64879L10.7095 5.67119H7.4759L7.79361 2.81062C7.83938 2.41014 7.55003 2.0489 7.14951 2.00476C6.74735 1.95899 6.3877 2.24832 6.34356 2.64879L6.00788 5.67119H2.72911C2.32696 5.67119 2 5.99811 2 6.40022C2 6.80233 2.32532 7.12925 2.72911 7.12925H5.84595L5.48577 10.3723H2.72911C2.32696 10.3723 2 10.6976 2 11.1013C2 11.5034 2.32532 11.8304 2.72911 11.8304H5.32383L5.00631 14.6892C4.96054 15.0897 5.24989 15.451 5.65041 15.4951ZM7.31397 7.12925L6.95379 10.3723H10.1874L10.5476 7.12925H7.31397Z" fill="#9D9D9D"/></svg>';
                    let h = document.createElement("span");
                    (h.innerHTML = d),
                      g.appendChild(v),
                      g.appendChild(h),
                      y.appendChild(g),
                      p.appendChild(y);
                  }
                $.appendChild(s), i.appendChild(p);
              }
              a.appendChild(i);
            }
            var f = ".child-tag";
            let C;
            n.appendChild(a),
              t.appendChild(n),
              (C = document.querySelectorAll(f)).forEach((e) => {
                let t = !1;
                e.addEventListener("click", function (e) {
                  e.preventDefault(),
                    e.stopPropagation(),
                    C.forEach((e) => {
                      (e.style.transform = ""),
                        (e.parentNode.parentNode.querySelector(
                          "ol"
                        ).style.display = "none");
                    }),
                    t
                      ? ((this.parentNode.parentNode.querySelector(
                          "ol"
                        ).style.display = "none"),
                        (this.style.transform = ""),
                        (t = !1))
                      : ((this.parentNode.parentNode.querySelector(
                          "ol"
                        ).style.display = "block"),
                        (this.style.transform = "rotate(90deg)"),
                        (t = !0));
                });
              });
            document
              .querySelector(".talk-tag")
              .addEventListener("click", (e) => {
                e.preventDefault();
                let t = document.querySelector(".textarea_box");
                console.log(t), console.log(e.target);
                let r = null;
                if (
                  ("A" == e.target.nodeName
                    ? (r = e.target.querySelector("span"))
                    : "SPAN" == e.target.nodeName && (r = e.target),
                  r)
                ) {
                  let l = t.selectionEnd,
                    a = t.value;
                  if ("UL" == r.parentNode.parentNode.parentNode.nodeName)
                    t.value =
                      a.slice(0, l) + "#" + r.innerHTML + " " + a.slice(l);
                  else {
                    let n =
                      r.parentNode.parentNode.parentNode.parentNode.querySelector(
                        "a span"
                      );
                    t.value =
                      a.slice(0, l) +
                      "#" +
                      n.innerHTML +
                      "/" +
                      r.innerHTML +
                      " " +
                      a.slice(l);
                  }
                  t.focus(), _();
                }
              });
          }
          document.querySelector(".tag-btn").addEventListener("click", () => {
            document.querySelector(".talk-tag")
              ? document.querySelector(".OwO-open")
                ? (document
                    .querySelector(".OwO-open")
                    .classList.remove("OwO-open"),
                  _())
                : (document.querySelector(".input-open") &&
                    document
                      .querySelector(".input-open")
                      .classList.remove("input-open"),
                  _())
              : ajaxText.createButterbar("大哥别按了，先配置信息哈~");
          });
        });
      })();
  },
  openInput: function () {
    let e = document.querySelector("i.user-img"),
      t = document.querySelector(".input_body");
    e.addEventListener("click", () => {
      t.classList.contains("input-open")
        ? t.classList.remove("input-open")
        : t.classList.add("input-open");
    });
  },
  ajaxText: function () {
    ajaxText = {
      clearButterbar: function () {
        document.querySelector(".butterBar") &&
          document.querySelector(".butterBar").remove();
      },
      createButterbar: function (e) {
        this.clearButterbar();
        let t = document.createDocumentFragment(),
          _ = document.createElement("div");
        _.className = "butterBar butterBar-center";
        let r = document.createElement("p");
        (r.className = "butterBar-message"),
          (r.innerText = e),
          _.appendChild(r),
          t.appendChild(_),
          document.querySelector("#app").appendChild(t),
          setTimeout(
            () =>
              document.querySelector(".butterBar") &&
              document.querySelector(".butterBar").remove(),
            3e3
          );
      },
    };
  },
};
app.saveInfo(),
  app.bindInfo(),
  app.sendTalk(),
  app.owo(),
  app.tagTalkBtn(),
  app.openInput();
